"""
Hmmm. Should I implement pyglibs and networking??
"""

import pygame, time, random, os
my_time = time
from pygame import *
import mappainter, isosprite, gui

def load_image(name, colorkey=None):
    """loads an image into memory"""
    fullname = os.path.join('data', name)
    try:
        image = pygame.image.load(fullname)
    except pygame.error, message:
        print 'Cannot load image:', fullname
        raise SystemExit, message
    image = image.convert()
    if colorkey is not None:
        if colorkey is -1:
            colorkey = image.get_at((0,0))
        image.set_colorkey(colorkey, RLEACCEL)
    return image, image.get_rect()


class Player(isosprite.Sprite):
    def __init__(self, globex, globey):
        isosprite.Sprite.__init__(self, globex, globey)
        self.isox = 0
        self.isoy = 0
        self.isoz = 1
        self.image, self.rect = load_image('player1.bmp', -1)
        self.old_image = self.image.copy()

        self.facing = 0
        self.isoz_offset = -10

    def rotate(self):
        self.facing += 5
        self.image = pygame.transform.rotate(self.old_image.copy(), self.facing)


class Herring(isosprite.Sprite):
    def __init__(self, globex, globey, locx, locy):
        isosprite.Sprite.__init__(self, globex, globey)
        self.isox = locx
        self.isoy = locy
        self.isoz = 1
        self.image, self.rect = load_image('prompt.bmp', -1)


class RedHerring(isosprite.Sprite):
    def __init__(self, globex, globey, locx, locy):
        isosprite.Sprite.__init__(self, globex, globey)
        self.isox = locx
        self.isoy = locy
        self.isoz = 1
        self.see_image, self.rect = load_image('enemy1.bmp', -1)
        self.inv_image, blah = load_image('enemy1.bmp', -1)
        self.image = self.see_image

        self.vis_counter = 0
        self.viewing_counter = 0
        self.viewing = True

    def update(self):
        self.vis_counter += 1
        if self.vis_counter >= 30:
            self.image = self.see_image
        else:
            self.image = self.inv_image
            
        if self.vis_counter == 40:
            self.vis_counter = 0


class Sonar:
    def __init__(self):
        self.pos = (450, 100)
        self.radius = 100
        self.sweep = 6
        self.emit_from = None
        self.blips = []
        self.blip_colors = ( (255,0,0),#red
                             (0,255,0),#green
                             (0,0,255))#blue

        self.players = []
        self.enemies = []
        self.neuts = []

    def draw(self, surf):
        pygame.draw.circle(surf, [125,125,125], self.pos, self.radius, 0)
        for blip in self.blips:
            if blip[0] == "r":
                r = pygame.rect.Rect(self.pos[0] + (blip[1] * 20), self.pos[1] + (blip[2] * 20), 5,5)
                pygame.draw.rect(surf, self.blip_colors[0], r, 1)
            elif blip[0] == "g":
                r = pygame.rect.Rect(self.pos[0] + (blip[1] * 20), self.pos[1] + (blip[2] * 20), 5,5)
                pygame.draw.rect(surf, self.blip_colors[1], r, 1)
            else:
                r = pygame.rect.Rect(self.pos[0] + (blip[1] * 20), self.pos[1] + (blip[2] * 20), 5,5)
                pygame.draw.rect(surf, self.blip_colors[2], r, 1)

    def sweep_map(self):
        self.blips = []
        if self.emit_from == None:
            for enemy in self.enemies:
                if enemy.isox <= self.sweep:
                    if enemy.isoy <= self.sweep:
                        self.blips.append(("r", enemy.isox, enemy.isoy))
                    else:
                        pass
                else:
                    pass
            for neut in self.neuts:
                if neut.isox <= self.sweep:
                    if neut.isoy <= self.sweep:
                        self.blips.append(("b", neut.isox, neut.isoy))
                    else:
                        pass
                else:
                    pass
            for player in self.players:
                if player.isox <= self.sweep:
                    if player.isoy <= self.sweep:
                        self.blips.append(("g", player.isox, player.isoy))

        else:
            for enemy in self.enemies:
                if enemy.isox >= self.emit_from[0] - self.sweep/2:
                    if enemy.isox <= self.emit_from[0] + self.sweep/2:
                        if enemy.isoy >= self.emit_from[1] - self.sweep/2:
                            if enemy.isoy <= self.emit_from[1] + self.sweep/2:
                                self.blips.append(("r",enemy.isox-self.emit_from[0],enemy.isoy-self.emit_from[1]))
                            else:pass
                        else:pass
                    else:pass
                else:pass
            for neut in self.neuts:
                if neut.isox >= self.emit_from[0] - self.sweep/2:
                    if neut.isox <= self.emit_from[0] + self.sweep/2:
                        if neut.isoy >= self.emit_from[1] - self.sweep/2:
                            if neut.isoy <= self.emit_from[1] + self.sweep/2:
                                self.blips.append(("b",neut.isox-self.emit_from[0],neut.isoy-self.emit_from[1]))
                            else:pass
                        else:pass
                    else:pass
                else:pass
            for player in self.players:
                if player.isox >= self.emit_from[0] - self.sweep/2:
                    if player.isox <= self.emit_from[0] + self.sweep/2:
                        if player.isoy >= self.emit_from[1] - self.sweep/2:
                            if player.isoy <= self.emit_from[1] + self.sweep/2:
                                self.blips.append(("g",player.isox-self.emit_from[0],player.isoy-self.emit_from[1]))
                            else:pass
                        else:pass
                    else:pass
                else:pass


    def sweep_from(self, loc):
        self.emit_from = loc

    def add_player(self, player):
        self.players.append(player)

    def add_enemy(self, enemy):
        self.enemies.append(enemy)

    def add_neut(self, neut):
        self.neuts.append(neut)

    def remove_player(self, player):
        self.players.remove(player)

    def remove_enemy(self, enemy):
        self.enemies.remove(enemy)

    def remove_neut(self, neut):
        self.neuts.remove(neut)


class Player_Timer:
    def __init__(self, duration):
        self.duration = duration
        self.finished = False
        self.cur_time = 0
        self.i = gui.MessageBox(100, 75, 200, 50, 2)
        self.whirly = 0

    def update(self):
        self.whirly += 1
        if self.whirly == 20:
            self.cur_time += 1
            self.whirly = 0
        if self.cur_time >= self.duration:
            self.finished = True
        if self.cur_time >= 0:
            self.i.add_message("time left: %s"%(self.duration-self.cur_time))

    def draw(self, surf):
        self.i.draw(surf)
        return


class game_states:
    def __init__(self):
        pygame.init()
        self.background_screen = pygame.display.set_mode((550,550))
        pygame.display.set_caption("Search for the Red Herring - 0.1")
        self.clock = pygame.time.Clock()
        self.background_screen.fill([0,0,0])
        self.on_state = 'Play'
        self.player_score = 0
        self.level = 0

    def menu(self):
        pass

    def play(self):
        #game time!
        
        globex, globey = 25, -200
        
        letters = "osmdw"#ocean floor, shallow, moderate, deep, whirlwind
        images = ['dirt.bmp',
                  'water_s.bmp',
                  'water_s.bmp',
                  'water_s.bmp',
                  'water_s.bmp']
        
        trans = [0,125,150,175,200]

        filename = 'mapsub_1.plm'
        ocean = mappainter.Isometric_Tile_Map(globex, globey, map_width = 5, map_height = 5)
        ocean.load_data(filename)
        ocean.load_tiles(letters, images, trans)

        level_view = gui.MessageBox(100, 125, 75, 50, 2)
        level_view.add_message("level: %s"%self.level)

        game_timer = Player_Timer(20.0-self.level)
        p_sonar = Sonar()
        p = Player(globex, globey)
        p_sonar.add_player(p)
        neut_group = []
        locs = [(0,1),(0,2),(0,3),(0,4),
                (1,0),(1,1),(1,2),(1,3),(1,4),
                (2,0),(2,1),(2,2),(2,3),(2,4),
                (3,0),(3,1),(3,2),(3,3),(3,4),
                (4,0),(4,1),(4,2),(4,3),(4,4)]
        
        for i in range(4):
            c = random.choice(locs)
            locs.remove(c)
            neut_group.append(Herring(globex, globey,c[0],c[1]))

        for i in neut_group:
            p_sonar.add_neut(i)

        c = random.choice(locs)
        locs.remove(c)
        enemy = RedHerring(globex, globey, c[0], c[1])
        p_sonar.add_enemy(enemy)

        exit_button = gui.Button(100, 25, 'button.bmp')

        while 1:
            self.clock.tick(20)

            #p_sonar.sweep_from(p)
            p_sonar.sweep_from((p.isox, p.isoy))
            p_sonar.sweep_map()
            #first draw the background
            self.background_screen.fill([0,0,0])
            ocean.draw_map(self.background_screen)

            #now draw units
            game_timer.draw(self.background_screen)
            level_view.draw(self.background_screen)
            p_sonar.draw(self.background_screen)
            p.draw(self.background_screen)
            for neut in neut_group:
                neut.draw(self.background_screen)
            enemy.draw(self.background_screen)
            exit_button.draw(self.background_screen, 'exit')
            m_d = gui.mouse_down(1)
            if exit_button.clicked(m_d) == True:
                print "you quit"
                self.on_state = "Exit-Now"
                break

            for event in pygame.event.get():
                if event.type == KEYDOWN:
                    if event.key == K_UP:
                        if p.isoy > 0:
                            p.isoy -= 1
                    if event.key == K_DOWN:
                        if p.isoy < 4:
                            p.isoy += 1

                    if event.key == K_LEFT:
                        if p.isox > 0:
                            p.isox -= 1
                    if event.key == K_RIGHT:
                        if p.isox < 4:
                            p.isox += 1


            for neut in neut_group:
                if neut.isox == p.isox:
                    if neut.isoy == p.isoy:
                        neut_group.remove(neut)
                        self.player_score += 25
                        p_sonar.remove_neut(neut)
            if p.isox == enemy.isox:
                if p.isoy == enemy.isoy:
                    self.on_state = "Play"
                    self.level += 1
                    break

            if game_timer.finished:
                self.on_state = "End"
                break

            enemy.update()
            game_timer.update()
            pygame.display.flip()
            pygame.event.pump()

    def end(self):
        hello = gui.MessageBox(200, 75, 200, 50, 2)
        hello.add_message("Game Over!")
        scr = gui.MessageBox(200, 150, 200, 50, 2)
        scr.add_message("score: "+str(self.player_score))
        lev = gui.MessageBox(200, 225, 200, 50, 2)
        lev.add_message("level: "+str(self.level)) 
        self.background_screen.fill([0,0,0])

        hello.draw(self.background_screen)
        scr.draw(self.background_screen)
        lev.draw(self.background_screen)
        pygame.display.flip()
        self.on_state = "Exit-Now"


game = game_states()
while 1:
    if game.on_state == 'Play':
        game.play()

    if game.on_state == 'End':
        game.end()

    if game.on_state == "Exit-Now":
        break
