"""This example shows how to create basic buttons and message boxes,
it also shows how to detect whether any given button is clicked"""
import gui, pygame

def main():
    #first set up all of the pygame stuff
    pygame.init()
    screen = pygame.display.set_mode((550, 650))
    pygame.display.set_caption("GUI 1")
    screen.fill([0,0,0])
    clock = pygame.time.Clock()

    #now we will create some buttons that will do various things
    #if you dont specify an image then the button is text only
    exit_button = gui.Button(125, 25)
    #centerx, centery, image 
    add_m_button = gui.Button(125, 50, 'button.bmp')
    s_up_button = gui.Button(475, 275, 'small_button.bmp')
    s_down_button = gui.Button(475, 325, 'small_button.bmp')
    s_left_button = gui.Button(250, 500, 'small_button.bmp')
    s_right_button = gui.Button(275, 500, 'small_button.bmp')

    #here we'll create a message box so most of the buttons have things to do
    #centerx, centery, box_width, box_height, lines_per_page, border image
    box = gui.MessageBox(100, 150, 300, 250, 13, image_name='message_box_border.bmp')
    
    num = 0
        
    while 1:
        screen.fill([0,0,0])

        #now we draw all of the buttons and the message box
        #the names on the buttons are specified here
        exit_button.draw(screen, 'exit')
        add_m_button.draw(screen, 'Add message')
        s_up_button.draw(screen, 'U')
        s_down_button.draw(screen, 'D')
        s_left_button.draw(screen, 'L')
        s_right_button.draw(screen, 'R')
        box.draw(screen)

        #This is where we see if the mouse button 1 is clicked
        #we are using the gui's mouse_down function,
        #but if you want to use pygame.event.get()
        #instead, any boolean will do
        m_c = gui.mouse_down(1)

        #now we do things based on which button was clicked
        if exit_button.clicked(m_c) == True:
            #if the first button is clicked the program ends
            pygame.quit()
            return 0

        if add_m_button.clicked(m_c) == True:
            #this button adds a message to the message box
            box.add_message("%sit's workiiinnnnggggg!!!blah!!!!!!!!blah!!!!!!!!!!!!!!!"%num)
            num += 1

        if s_up_button.clicked(m_c) == True:
            #this button will scroll up the messages if there are too many to show on the page
            box.scroll_vert('U')

        if s_down_button.clicked(m_c) == True:
            #this button will scroll down the messages if we arent on the latest message
            box.scroll_vert('D')

        if s_left_button.clicked(m_c) == True:
            #this button will scroll the messages to the left
            box.scroll_horz('L')

        if s_right_button.clicked(m_c) == True:
            #this will scroll the messages to the right
            box.scroll_horz('R')
            
        pygame.display.flip()

r = 1
if r == 1:
    main()
