"""
This example shows how to create more customized buttons and message boxes, and input boxes,
type \q to quit or click quit button.
"""
import gui, pygame

def main():
    #first set up all of the pygame stuff
    pygame.init()
    screen = pygame.display.set_mode((550, 650))
    pygame.display.set_caption("GUI 1")
    screen.fill([0,0,0])
    clock = pygame.time.Clock()

    #we create our button the same as before
    exit_button = gui.Button(125, 25, 'button.bmp')
    #but we can make them more customizable by changing fonts/sizes, colors, toggling highlighting, etc.
    #to toggle highlighting
    #exit_button.toggle_highlighting('F')#(T)rue or (F)alse
    
    #to set the font/color
    exit_button.Set_Font(font = pygame.font.Font('data/croobie.ttf', 23),#font(file, size)
                         color = (255, 0, 240))#color(purple)

    #to set font details (italic, etc.)
    exit_button.font.set_italic(True)
    exit_button.font.set_bold(True)
    exit_button.font.set_underline(True)

    #we create a message box
    #centerx, centery, box_width, box_height, lines per page, max horizontal scroll(pixels), image
    box = gui.MessageBox(100, 150, 300, 250, 13, max_horz_scroll=50, image_name='message_box_border.bmp')
    box.Set_Font(font = pygame.font.Font('data/croobie.ttf', 30),
                 color = (0,25,150))
    box.font.set_italic(True)


    #and finally we'll create an input box
    #centerx, centery, prompt, input_area_width, input_area_height, input_box_image, prompt image
    input_box = gui.InputBox(25, 475, 'prompt', 350, 30, max_letters = 45,
                             box_image = 'input_box.bmp', prompt_image='prompt.bmp')
    input_box.Set_Font(font = pygame.font.Font(None, 26), color = (240,255,0))

    while 1:
        
        input_box.get_input()
        message = input_box.get_completed_message()
        if message is not None:
            box.add_message(message)
        if message == "\q":
            pygame.quit()
            return 0

        m_c = gui.mouse_down(1)
        if exit_button.clicked(m_c) == True:
            pygame.quit()
            return 0
        screen.fill([0,0,0])
        exit_button.draw(screen, 'exit')
        box.draw(screen)
        input_box.draw(screen)

        pygame.display.flip()
        m_c = 0

r = 1
if r == 1:
    main()
