"""
This example shows how to make an 'isometric' sprite and move it around on the map using gui
"""
import MapPainter, pygame, IsoSprite, gui
from MapPainter import *

def load_image(name, colorkey=None):
    """loads an image into memory"""
    fullname = os.path.join('data', name)
    try:
        image = pygame.image.load(fullname)
    except pygame.error, message:
        print 'Cannot load image:', fullname
        raise SystemExit, message
    image = image.convert()
    if colorkey is not None:
        if colorkey is -1:
            colorkey = image.get_at((0,0))
        image.set_colorkey(colorkey, RLEACCEL)
    return image, image.get_rect()

class descendant(IsoSprite.Sprite):
    def __init__(self, globex, globey, screen):
        IsoSprite.Sprite.__init__(self, globex, globey)
        #with the tile positions tile 0 is  the first tile
        self.isox = 3
        self.isoy = 6
        self.isoz = 1
        self.image, self.rect = load_image('mud.bmp', -1)
        self.draw(screen)

def main():
    pygame.init()

    global screen
    screen = pygame.display.set_mode((640, 480))
    pygame.display.set_caption("Eskimo Tutorial")

    screen.fill([0,0,0])
        
    pygame.display.flip()

    globex = 0
    globey = 0

    letters = "sgdw"
    images = ['snow.bmp',
    'grass.bmp',
    'dirt.bmp',
    'water_s.bmp']

    transparency = [0,0,0,125]

    filename = 'plate0_0.cfg'
    world = Isometric_Tile_Map(globex,globey)
    world.load_data(filename)
    world.load_tiles(letters, images, transparency)

    a = descendant(globex, globey, screen)

    button_exit = gui.Button(100,400,'button.bmp')

    button_north = gui.Button(550, 350, 'iso_button.bmp')
    button_south = gui.Button(450, 400, 'iso_button.bmp')
    button_east = gui.Button(550, 400, 'iso_button.bmp')
    button_west = gui.Button(450, 350, 'iso_button.bmp')

    while 1:
        screen.fill([0,0,0])
        world.draw_map(screen)
        a.draw(screen)
        button_exit.draw(screen, 'exit')
        button_north.draw(screen, 'north')
        button_south.draw(screen, 'south')
        button_east.draw(screen, 'east')
        button_west.draw(screen, 'west')
        
        m_c = gui.mouse_down(1)

        if button_exit.clicked(m_c) == True:
            pygame.quit()
            return 0

        #move the sprite "a"
        if button_north.clicked(m_c) == True:
            a.isoy -= 1
        if button_south.clicked(m_c) == True:
            a.isoy += 1
        if button_east.clicked(m_c) == True:
            a.isox += 1
        if button_west.clicked(m_c) == True:
            a.isox -= 1
            
        pygame.display.flip()
        m_c = 0

r = 1
if r == 1:
    main()
