"""
This example shows how to use IsoSprite's built-in move commands to move sprites around on the tile.
NOTE: your character will look like it is moving up and down if it is caught on the very edge of a cliff.
Note:The move commands are currently VERY buggy, you should only use the move_north,south,east, or west commands
     the other commands do not currently work correctly.
"""
import MapPainter, pygame, IsoSprite, gui, pixelperfect
from MapPainter import *

try:
    import psyco
    psyco.background()
except:
    pass
def load_image(name, colorkey=None):
    """loads an image into memory"""
    fullname = os.path.join('data', name)
    try:
        image = pygame.image.load(fullname)
    except pygame.error, message:
        print 'Cannot load image:', fullname
        raise SystemExit, message
    image = image.convert()
    if colorkey is not None:
        if colorkey is -1:
            colorkey = image.get_at((0,0))
        image.set_colorkey(colorkey, RLEACCEL)
    return image, image.get_rect()

class descendant(IsoSprite.Sprite):
    def __init__(self, globex, globey, screen):
        IsoSprite.Sprite.__init__(self, globex, globey)
        #with the tile positions tile 0 is  rendered as tile 1
        self.isox = 3
        self.isoy = 6
        self.isoz = 1
        self.image, self.rect = load_image('mud.bmp', -1)

def main():
    pygame.init()

    global screen
    screen = pygame.display.set_mode((640, 480))
    pygame.display.set_caption("Eskimo Tutorial")

    screen.fill([0,0,0])
    clock = pygame.time.Clock()
        
    pygame.display.flip()

    globex = 0
    globey = 0

    letters = "sgdw"
    images = ['snow.bmp',
    'grass.bmp',
    'dirt.bmp',
    'water_s.bmp']

    transparency = [0,0,0,125]

    filename = 'plate0_1.cfg'
    world = Isometric_Tile_Map(globex,globey)
    world.load_data(filename)
    world.load_tiles(letters, images, transparency)

    a = descendant(globex, globey, screen)
    a_tile = gui.MessageBox(25, 25, 100, 50, 2)

    button_exit = gui.Button(225,400,'button.bmp')

    button_north = gui.Button(550, 350, 'iso_button.bmp')
    button_south = gui.Button(450, 400, 'iso_button.bmp')
    button_east = gui.Button(550, 400, 'iso_button.bmp')
    button_west = gui.Button(450, 350, 'iso_button.bmp')
    move_north = False
    move_south = False
    move_east = False
    move_west = False

    while 1:
        clock.tick(10)
        screen.fill([0,0,0])
        world.draw_map(screen)
        a.draw(screen)
        a_tile.draw(screen)
        button_exit.draw(screen, 'exit')
        button_north.draw(screen, 'north')
        button_south.draw(screen, 'south')
        button_east.draw(screen, 'east')
        button_west.draw(screen, 'west')
        
        m_c = gui.mouse_down(1)
        
        if button_exit.clicked(m_c) == True:
            pygame.quit()
            return 0

        #find out which direction to move
        if button_north.clicked(m_c) == True:
            move_north = True
            move_south = False
            move_east = False
            move_west = False
        if button_south.clicked(m_c) == True:
            move_north = False
            move_south = True
            move_east = False
            move_west = False
        if button_east.clicked(m_c) == True:
            move_north = False
            move_south = False
            move_east = True
            move_west = False
        if button_west.clicked(m_c) == True:
            move_north = False
            move_south = False
            move_east = False
            move_west = True

        #now we move the sprite, making sure that it doesnt leave the map
        if move_north == True:
            if not a.isoy == 0:
                a.move_north(world.map_data)
        if move_south == True:
            if not a.isoy == 9:
                a.move_south(world.map_data)
        if move_east == True:
            if not a.isox == 9:
                a.move_east(world.map_data)
        if move_west == True:
            if not a.isox == 0:
                a.move_west(world.map_data)

        #and finally, display which tile we are on
        a_tile.add_message("x %r, y %s"%(a.isox,a.isoy))
            
        pygame.display.flip()
        pygame.event.pump()

r = 1
if r == 1:
    main()
