import pygame
from pygame.locals import *        
        
class Sprite:
    def __init__(self, globex, globey, tile_size=None):
        if not tile_size == None:
            self.tile_size = tile_size
        else:
            self.tile_size = 100
        self.globex = globex
        self.globey = globey

        self.isoz_offset = 0
        

        self.sub_tilex = self.tile_size/4
        self.sub_tiley = self.tile_size/4

        self.on_sub_tile = [self.sub_tilex/2,
                            self.sub_tiley/2]
        self.space_per_tile = self.tile_size/self.sub_tilex

    def set_num_sub_tiles(self,num):
        self.sub_tilex = num
        self.sub_tiley = num
        self.on_sub_tile = [self.sub_tilex/2,
                            self.sub_tiley/2]
        self.space_per_tile = self.tile_size/self.sub_tilex

    def sub_tile_grid_loc(self):
        numx = self.on_sub_tile[0]
        numy = self.on_sub_tile[1]
        half = self.space_per_tile/2
        quart = self.space_per_tile/4
        tilex = numx * half -(half * numy) + self.tile_size/2
        tiley = numx * quart + (half * numy - quart)-(quart*numy)-self.isoz_offset
        tile = [tilex,tiley]
        return tile

    def place_grid_loc(self, x='pass', y='pass',z='pass'):
        half = self.tile_size/2
        quart = self.tile_size/4
        if (x,y,z) == ('pass','pass','pass'):
            numx = self.isox
            numy = self.isoy
            height = self.isoz
        else:
            numx = x
            numy = y
            height = z
        tilex = numx * half -(half * numy)-self.globex
        tiley = numx * quart + (half * numy - quart)-(quart*numy)-(quart*height)-self.globey
        tile = [tilex+250,tiley]
        a = self.sub_tile_grid_loc()
        tile[0] = tile[0] + a[0]-self.image.get_width() / 2
        tile[1] = tile[1] + a[1]-self.image.get_height()
        return tile
            
    def draw(self, screen):
        self.screen = screen
        i = self.image
        self.screen.blit(i, self.place_grid_loc())
        return


    def check(self):
        if self.on_sub_tile[0] >= self.sub_tilex:
            self.on_sub_tile[0] = 0
            self.isox += 1
        elif self.on_sub_tile[0] <= 0:
            self.on_sub_tile[0] = self.sub_tilex
            self.isox -= 1

        if self.on_sub_tile[1] >= self.sub_tiley:
            self.on_sub_tile[1] = 0
            self.isoy += 1
        elif self.on_sub_tile[1] <= 0:
            self.on_sub_tile[1] = self.sub_tiley
            self.isoy -= 1

    def should_move_up(self, map_data, d):
        if d == 'n':
            try:
                if map_data[self.isoz+1][self.isoy-1][self.isox] != '-':
                    try:
                        if map_data[self.isoz+2][self.isoy-1][self.isox] == '-':self.isoz_offset += 2
                        else:pass
                    except:self.isoz_offset += 2
            except:pass
            try:
                if map_data[self.isoz][self.isoy-1][self.isox] == '-':
                    try:
                        if map_data[self.isoz-1][self.isoy-1][self.isox] != '-':self.isoz_offset -= 2
                        else:pass
                    except:self.isoz_offset -= 2
                else:pass
            except:pass

        if d == 's':
            try:
                if map_data[self.isoz+1][self.isoy+1][self.isox] != '-':
                    try:
                        if map_data[self.isoz+2][self.isoy+1][self.isox] == '-':self.isoz_offset += 2
                        else:pass
                    except:self.isoz_offset += 2
            except:pass
            try:
                if map_data[self.isoz][self.isoy+1][self.isox] == '-':
                    try:
                        if map_data[self.isoz-1][self.isoy+1][self.isox] != '-':self.isoz_offset -= 2
                        else:pass
                    except:self.isoz_offset -= 2
                else:pass
            except:pass

        if d == 'e':
            try:
                if map_data[self.isoz+1][self.isoy][self.isox+1] != '-':
                    try:
                        if map_data[self.isoz+2][self.isoy][self.isox+1] == '-':self.isoz_offset += 2
                        else:pass
                    except:self.isoz_offset += 2
            except:pass
            try:
                if map_data[self.isoz][self.isoy][self.isox+1] == '-':
                    try:
                        if map_data[self.isoz-1][self.isoy][self.isox+1] != '-':self.isoz_offset -= 2
                        else:pass
                    except:self.isoz_offset -= 2
                else:pass
            except:pass

        if d == 'w':
            try:
                if map_data[self.isoz+1][self.isoy][self.isox-1] != '-':
                    try:
                        if map_data[self.isoz+2][self.isoy][self.isox-1] == '-':self.isoz_offset += 2
                        else:pass
                    except:self.isoz_offset += 2
            except:pass
            try:
                if map_data[self.isoz][self.isoy][self.isox-1] == '-':
                    try:
                        if map_data[self.isoz-1][self.isoy][self.isox-1] != '-':self.isoz_offset -= 2
                        else:pass
                    except:self.isoz_offset -= 2
                else:pass
            except:pass

        if d == 'nw':
            try:
                if map_data[self.isoz+1][self.isoy-1][self.isox-1] != '-':
                    try:
                        if map_data[self.isoz+2][self.isoy-1][self.isox-1] == '-':self.isoz_offset += 2
                        else:pass
                    except:self.isoz_offset += 2
            except:pass
            try:
                if map_data[self.isoz][self.isoy-1][self.isox-1] == '-':
                    try:
                        if map_data[self.isoz-1][self.isoy-1][self.isox-1] != '-':self.isoz_offset -= 2
                        else:pass
                    except:self.isoz_offset -= 2
                else:pass
            except:pass

        if d == 'ne':
            try:
                if map_data[self.isoz+1][self.isoy-1][self.isox+1] != '-':
                    try:
                        if map_data[self.isoz+2][self.isoy-1][self.isox+1] == '-':self.isoz_offset += 2
                        else:pass
                    except:self.isoz_offset += 2
            except:pass
            try:
                if map_data[self.isoz][self.isoy-1][self.isox+1] == '-':
                    try:
                        if map_data[self.isoz-1][self.isoy-1][self.isox+1] != '-':self.isoz_offset -= 2
                        else:pass
                    except:self.isoz_offset -= 2
                else:pass
            except:pass

        if d == 'sw':
            try:
                if map_data[self.isoz+1][self.isoy+1][self.isox-1] != '-':
                    try:
                        if map_data[self.isoz+2][self.isoy+1][self.isox-1] == '-':self.isoz_offset += 2
                        else:pass
                    except:self.isoz_offset += 2
                if map_data[self.isoz][self.isoy+1][self.isox-1] == '-':
                    try:
                        if map_data[self.isoz-1][self.isoy+1][self.isox-1] != '-':self.isoz_offset -= 2
                        else:pass
                    except:self.isoz_offset -= 2
                else:pass
            except:pass

        if d == 'se':
            try:
                if map_data[self.isoz+1][self.isoy+1][self.isox+1] != '-':
                    try:
                        if map_data[self.isoz+2][self.isoy+1][self.isox+1] == '-':self.isoz_offset += 2
                        else:pass
                    except:self.isoz_offset += 2
            except:pass
            try:
                if map_data[self.isoz][self.isoy+1][self.isox+1] == '-':
                    try:
                        if map_data[self.isoz-1][self.isoy+1][self.isox+1] != '-':self.isoz_offset -= 2
                        else:pass
                    except:self.isoz_offset -= 2
                else:pass
            except:pass

        if self.isoz_offset >= self.tile_size/4:
            self.isoz += 1
            self.isoz_offset = 0
        if self.isoz_offset <= -self.tile_size/4:
            self.isoz -= 1
            self.isoz_offset = 0
        

    def move_north(self, map_data):
        self.on_sub_tile[1] -= 4
        
        self.check()
        self.should_move_up(map_data, 'n')


    def move_south(self, map_data):
        self.on_sub_tile[1] += 2
        self.check()
        self.should_move_up(map_data, 's')


    def move_east(self, map_data):
        self.on_sub_tile[0] += 2
        self.check()
        self.should_move_up(map_data, 'e')


    def move_west(self, map_data):
        self.on_sub_tile[0] -= 2
        self.check()
        self.should_move_up(map_data, 'w')

    def move_north_west(self, map_data):
        self.on_sub_tile[0] -= 4
        self.on_sub_tile[1] -= 4
        self.check()
        self.should_move_up(map_data, 'nw')

    def move_north_east(self, map_data):
        self.on_sub_tile[0] += 4
        self.on_sub_tile[1] -= 4
        self.check()
        self.should_move_up(map_data, 'ne')

    def move_south_west(self, map_data):
        self.on_sub_tile[0] -= 4
        self.on_sub_tile[1] += 4
        self.check()
        self.should_move_up(map_data, 'sw')

    def move_south_east(self, map_data):
        self.on_sub_tile[0] += 4
        self.on_sub_tile[1] += 4
        self.check()
        self.should_move_up(map_data, 'se')


        
    
